unit uofe_tipo_problema_grupo;

{$mode delphi}

interface

uses
  Classes, SysUtils, xmatdefs, ubtree, uoddface_table_nid;


(*

CREATE TABLE ofe_tipo_problema_grupo (
    tipo integer NOT NULL,
    grupo integer NOT NULL
);



  *)

  type

    { ofe_tipo_problema_grupo }

    ofe_tipo_problema_grupo = class( TRec_Key )
      tipo, grupo:integer;

      constructor Create(
        tipo, grupo: integer );

      procedure WriteToBin( f: TStream );  override;
      constructor LoadFromBin( f: TStream ); override;
      function KeyCompare( a, b : TRec_key ): integer; override;
      procedure CopyRec( a: TRec_key ); override;

    end;



    { ofe_tipo_problema_grupos }

    ofe_tipo_problema_grupos = class( TTable_nid )
      constructor Create;
      constructor LoadFromBin( f: TStream );
    end;

implementation

{ ofe_tipo_problema_grupos }

constructor ofe_tipo_problema_grupos.Create;
begin
  inherited Create( ofe_tipo_problema_grupo );
end;

constructor ofe_tipo_problema_grupos.LoadFromBin(f: TStream);
begin
  inherited LoadFromBin( f, ofe_tipo_problema_grupo  );
end;


{ ofe_tipo_problema_grupo }

constructor ofe_tipo_problema_grupo.Create(tipo, grupo: integer);
begin
  inherited Create;
  self.tipo:= tipo;
  self.grupo:= grupo;
end;


procedure ofe_tipo_problema_grupo.WriteToBin(f: TStream);
begin
  f.write( tipo, sizeOf( tipo ) );
  f.Write( grupo, sizeOf( grupo ) );
end;

constructor ofe_tipo_problema_grupo.LoadFromBin(f: TStream);
begin
  inherited Create;
  f.Read( tipo, sizeOf( tipo ) );
  f.Read( grupo, sizeOf( grupo ) );
end;

function ofe_tipo_problema_grupo.KeyCompare(a, b: TRec_key): integer;
var
  dif: Int64;
begin
  dif := (a as ofe_tipo_problema_grupo).grupo - (b as ofe_tipo_problema_grupo).grupo;
  if dif < 0 then
    Result := -1
  else if dif > 0 then
    Result := 1
  else
  begin
    dif:= (a as ofe_tipo_problema_grupo).tipo - (b as ofe_tipo_problema_grupo).tipo;
    if dif < 0 then
      result:= -1
    else if dif > 0 then
      Result := 1
    else
      result:= 0;
  end;
end;

procedure ofe_tipo_problema_grupo.CopyRec(a: TRec_key);
var
  a_: ofe_tipo_problema_grupo;
begin
  a_:= a as ofe_tipo_problema_grupo;
  tipo:= a_.tipo;
  grupo:= a_.grupo;
end;

end.
