unit uofe_usuarios;

{$mode delphi}

interface

uses
  Classes, SysUtils, xmatdefs, ubtree, uoddface_table_nid;


(*

CREATE TABLE ofe_usuarios (
    nid integer NOT NULL,
    email character varying(60) NOT NULL,
    clave character varying(200) NOT NULL,
    tipo integer DEFAULT 0 NOT NULL,
    clavene character varying(200) NOT NULL,
    codigo character varying(20) DEFAULT ''::character varying,
    grupo integer DEFAULT 0
);

CREATE SEQUENCE ofe_usuarios_nid_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE ofe_usuarios_nid_seq OWNED BY ofe_usuarios.nid;



  *)

  type

    { ofe_usuario }

    ofe_usuario = class( TRec_Nid )
      email: string;
      clave: string;
      tipo: integer;
      clavene: string;
      codigo: string;
      grupo: integer;

      constructor Create(
        email: string;
        clave: string;
        tipo: integer;
        clavene: string;
        codigo: string;
        grupo: integer
       );

      procedure WriteToBin( f: TStream );  override;
      constructor LoadFromBin( f: TStream ); override;

      procedure CopyRec(a: TRec_key); override;

    end;



    { ofe_usuarios }

    ofe_usuarios = class( TTable_nid )
      constructor Create;
      constructor LoadFromBin( f: TStream );
    end;

implementation

{ ofe_usuarios }

constructor ofe_usuarios.Create;
begin
  inherited Create( ofe_usuario );
end;

constructor ofe_usuarios.LoadFromBin(f: TStream);
begin
  inherited LoadFromBin( f, ofe_usuario  );
end;


{ ofe_usuario }

constructor ofe_usuario.Create(email: string; clave: string; tipo: integer;
  clavene: string; codigo: string; grupo: integer);
begin
  inherited Create( nid );
  self.email:= email;
  self.clave:= clave;
  self.tipo:= tipo;
  self.clavene:= clavene;
  self.codigo:= codigo;
  self.grupo:= grupo;
end;


procedure ofe_usuario.WriteToBin(f: TStream);
begin
  inherited WriteToBin( f );
  f.WriteAnsiString( email );
  f.WriteAnsiString( clave );
  f.Write(tipo, sizeOf( tipo ));
  f.WriteAnsiString( clavene );
  f.WriteAnsiString( codigo );
  f.Write( grupo, sizeOf( grupo ) );
end;

constructor ofe_usuario.LoadFromBin(f: TStream);
begin
  inherited LoadFromBin( f );
  email:= f.ReadAnsiString;
  clave:= f.ReadAnsiString;
  f.Read(tipo, sizeOf( tipo ));
  clavene:= f.ReadAnsiString;
  codigo:= f.ReadAnsiString;
  f.Read( grupo, sizeOf( grupo ) );
end;

procedure ofe_usuario.CopyRec(a: TRec_key);
var
  a_: ofe_usuario;
begin
  a_:= a as ofe_usuario;
  inherited CopyRec( a_);
  self.email:= a_.email;
  self.clave:= a_.clave;
  self.tipo:= a_.tipo;
  self.clavene:= a_.clavene;
  self.codigo:= a_.codigo;
  self.grupo:= a_.grupo;
end;

end.

